searchNodes=[{"doc":"This module provides the information from .formatter.exs .","ref":"Rewrite.DotFormatter.html","title":"Rewrite.DotFormatter","type":"module"},{"doc":"Returns the option inputs from the .formatter.exs .","ref":"Rewrite.DotFormatter.html#inputs/0","title":"Rewrite.DotFormatter.inputs/0","type":"function"},{"doc":"Returns the option locals_without_parens from the .formatter.exs .","ref":"Rewrite.DotFormatter.html#locals_without_parens/0","title":"Rewrite.DotFormatter.locals_without_parens/0","type":"function"},{"doc":"Returns the options from the .formatter.exs .","ref":"Rewrite.DotFormatter.html#opts/0","title":"Rewrite.DotFormatter.opts/0","type":"function"},{"doc":"The %Project{} contains all %Rewrite.Sources{} of a project.","ref":"Rewrite.Project.html","title":"Rewrite.Project","type":"module"},{"doc":"Returns conflicts between sources. Sources with the same path have a conflict.","ref":"Rewrite.Project.html#conflicts/1","title":"Rewrite.Project.conflicts/1","type":"function"},{"doc":"Counts the items of the given type in the project . The type :sources returns the count for all sources in the project, including scripts. The type :scripts returns the count of all sources with a path that ends with &quot;.exs&quot; .","ref":"Rewrite.Project.html#count/2","title":"Rewrite.Project.count/2","type":"function"},{"doc":"Creates a %Project{} from the given sources.","ref":"Rewrite.Project.html#from_sources/1","title":"Rewrite.Project.from_sources/1","type":"function"},{"doc":"Returns true if any source has one or more issues.","ref":"Rewrite.Project.html#issues?/1","title":"Rewrite.Project.issues?/1","type":"function"},{"doc":"Return a %Project{} where each source is the result of invoking fun on each source of the given project .","ref":"Rewrite.Project.html#map/2","title":"Rewrite.Project.map/2","type":"function"},{"doc":"Creates a %Project{} from the given inputs .","ref":"Rewrite.Project.html#read!/1","title":"Rewrite.Project.read!/1","type":"function"},{"doc":"Saves all sources in the project to disk. This function call Rewrite.Source.save/1 on all sources in the project . The optional second argument accepts a list of paths for files to be excluded.","ref":"Rewrite.Project.html#save/2","title":"Rewrite.Project.save/2","type":"function"},{"doc":"Returns the %Rewrite.Source{} for the given path . Returns an :ok tuple with the found source, if no or multiple sources are available an :error is returned.","ref":"Rewrite.Project.html#source/2","title":"Rewrite.Project.source/2","type":"function"},{"doc":"Same as source/2 but raises a ProjectError .","ref":"Rewrite.Project.html#source!/2","title":"Rewrite.Project.source!/2","type":"function"},{"doc":"Returns the %Rewrite.source{} for the given module . Returns an :ok tuple with the found source, if no or multiple sources are available an :error is returned.","ref":"Rewrite.Project.html#source_by_module/2","title":"Rewrite.Project.source_by_module/2","type":"function"},{"doc":"Same as source_by_module/2 but raises a ProjectError .","ref":"Rewrite.Project.html#source_by_module!/2","title":"Rewrite.Project.source_by_module!/2","type":"function"},{"doc":"Returns all sources sorted by path.","ref":"Rewrite.Project.html#sources/1","title":"Rewrite.Project.sources/1","type":"function"},{"doc":"Returns a list of %Source{} for the given path . It is possible that the project contains multiple sources with the same path. The function conflicts/1 returns all conflicts in a project and the function save/2 returns an error tuple when trying to save a project with conflicts. It is up to the user of rewrite to handle conflicts. Examples iex&gt; source = Source . from_string ( ...&gt; &quot;&quot;&quot; ...&gt; defmodule MyApp.Mode do ...&gt; end ...&gt; &quot;&quot;&quot; , ...&gt; &quot;my_app/mode.ex&quot; ...&gt; ) iex&gt; project = Project . from_sources ( [ source ] ) iex&gt; Project . sources ( project , &quot;my_app/mode.ex&quot; ) [ source ] iex&gt; Project . sources ( project , &quot;foo&quot; ) [ ] iex&gt; a = Source . from_string ( &quot;:a&quot; , &quot;a.ex&quot; ) iex&gt; b = Source . from_string ( &quot;:b&quot; , &quot;b.ex&quot; ) iex&gt; project = Project . from_sources ( [ a , b ] ) iex&gt; update = Source . update ( a , :test , path : &quot;b.ex&quot; ) iex&gt; project = Project . update ( project , update ) iex&gt; Project . sources ( project , &quot;a.ex&quot; ) [ ] iex&gt; Project . sources ( project , &quot;b.ex&quot; ) [ b , update ]","ref":"Rewrite.Project.html#sources/2","title":"Rewrite.Project.sources/2","type":"function"},{"doc":"Returns a list of %Rewrite.Source{} with an implementation for the given module .","ref":"Rewrite.Project.html#sources_by_module/2","title":"Rewrite.Project.sources_by_module/2","type":"function"},{"doc":"Returns the unreferenced sources. Unreferenced source are sources whose original path is no longer part of the project.","ref":"Rewrite.Project.html#unreferenced/1","title":"Rewrite.Project.unreferenced/1","type":"function"},{"doc":"Updates the project with the given source . If the source is part of the project the source will be replaced, otherwise the source will be added.","ref":"Rewrite.Project.html#update/2","title":"Rewrite.Project.update/2","type":"function"},{"doc":"","ref":"Rewrite.Project.html#t:id/0","title":"Rewrite.Project.id/0","type":"type"},{"doc":"","ref":"Rewrite.Project.html#t:t/0","title":"Rewrite.Project.t/0","type":"type"},{"doc":"","ref":"Rewrite.Project.html#t:wildcard/0","title":"Rewrite.Project.wildcard/0","type":"type"},{"doc":"A representation of some source in a project. The %Source{} contains the code of the file given by path . The module contains Source.update/3 to update the path and/or the code . The changes are recorded in the updates list. The struct also holds issues for the source.","ref":"Rewrite.Source.html","title":"Rewrite.Source","type":"module"},{"doc":"Adds the given issue to the source .","ref":"Rewrite.Source.html#add_issue/2","title":"Rewrite.Source.add_issue/2","type":"function"},{"doc":"Adds the given issues to the source .","ref":"Rewrite.Source.html#add_issues/2","title":"Rewrite.Source.add_issues/2","type":"function"},{"doc":"Returns the AST for the given %Source . The returned extended AST is generated with Sourceror.parse_string/1 . Uses the current code of the source . Examples iex&gt; &quot;def foo, do: :foo&quot; |&gt; Source . from_string ( ) |&gt; Source . ast ( ) { :def , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 1 ] , [ { :foo , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 5 ] , nil } , [ { { :__block__ , [ trailing_comments : [ ] , leading_comments : [ ] , format : :keyword , line : 1 , column : 10 ] , [ :do ] } , { :__block__ , [ trailing_comments : [ ] , leading_comments : [ ] , line : 1 , column : 14 ] , [ :foo ] } } ] ] }","ref":"Rewrite.Source.html#ast/1","title":"Rewrite.Source.ast/1","type":"function"},{"doc":"Returns the current code for the given source .","ref":"Rewrite.Source.html#code/1","title":"Rewrite.Source.code/1","type":"function"},{"doc":"Returns the code of a source for the given version . Examples iex&gt; bar = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; def bar, do: :bar ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; foo = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; source = Source . from_string ( bar ) iex&gt; source = Source . update ( source , :example , code : foo ) iex&gt; Source . code ( source ) == foo true iex&gt; Source . code ( source , 2 ) == foo true iex&gt; Source . code ( source , 1 ) == bar true","ref":"Rewrite.Source.html#code/2","title":"Rewrite.Source.code/2","type":"function"},{"doc":"Compares the path values of the given sources. Examples iex&gt; a = Source . from_string ( &quot;:foo&quot; , &quot;a.exs&quot; ) iex&gt; Source . compare ( a , a ) :eq iex&gt; b = Source . from_string ( &quot;:foo&quot; , &quot;b.exs&quot; ) iex&gt; Source . compare ( a , b ) :lt iex&gt; Source . compare ( b , a ) :gt","ref":"Rewrite.Source.html#compare/2","title":"Rewrite.Source.compare/2","type":"function"},{"doc":"Returns true if the %Source{} was created. Created means here that a new file is written when saving. Examples iex&gt; source = Source . read! ( &quot;test/fixtures/source/simple.ex&quot; ) ...&gt; Source . created? ( source ) false iex&gt; source = Source . from_string ( &quot;:foo&quot; ) ...&gt; Source . created? ( source ) true iex&gt; source = Source . from_string ( &quot;:foo&quot; , &quot;test/fixtures/new.ex&quot; , Test ) ...&gt; Source . created? ( source ) true","ref":"Rewrite.Source.html#created?/1","title":"Rewrite.Source.created?/1","type":"function"},{"doc":"Marks the given source as deleted. This function set the path of the given source to nil .","ref":"Rewrite.Source.html#del/2","title":"Rewrite.Source.del/2","type":"function"},{"doc":"Returns iodata showing all diffs of the given source . Examples iex&gt; code = &quot;&quot;&quot; ...&gt; def foo( x ) do ...&gt; {:x, ...&gt; x} ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; formatted = code |&gt; Code . format_string! ( ) |&gt; IO . iodata_to_binary ( ) iex&gt; source = Source . from_string ( code ) iex&gt; source |&gt; Source . diff ( ) |&gt; IO . iodata_to_binary ( ) &quot;&quot; iex&gt; source ...&gt; |&gt; Source . update ( Test , code : formatted ) ...&gt; |&gt; Source . diff ( color : false ) ...&gt; |&gt; IO . iodata_to_binary ( ) &quot;&quot;&quot; 1 - |def foo( x ) do 2 - | {:x, 3 - | x} 1 + |def foo(x) do 2 + | {:x, x} 4 3 |end 5 4 | &quot;&quot;&quot;","ref":"Rewrite.Source.html#diff/2","title":"Rewrite.Source.diff/2","type":"function"},{"doc":"Creates a new %Source{} from the given ast . Examples iex&gt; ast = Sourceror . parse_string! ( &quot;a + b&quot; ) iex&gt; source = Source . from_ast ( ast ) iex&gt; source . modules [ ] iex&gt; source . code &quot;a + b&quot;","ref":"Rewrite.Source.html#from_ast/3","title":"Rewrite.Source.from_ast/3","type":"function"},{"doc":"Creates a new %Source{} from the given string . Examples iex&gt; source = Source . from_string ( &quot;a + b&quot; ) iex&gt; source . modules [ ] iex&gt; source . code &quot;a + b&quot;","ref":"Rewrite.Source.html#from_string/3","title":"Rewrite.Source.from_string/3","type":"function"},{"doc":"Returns true if the source has issues for the given version . The version argument also accepts :actual and :all to check whether the source has problems for the actual version or if there are problems at all. Examples iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( &quot;some/where/plus.exs&quot; ) ...&gt; |&gt; Source . add_issue ( %{ issue : :foo } ) ...&gt; |&gt; Source . update ( :example , path : &quot;some/where/else/plus.exs&quot; ) ...&gt; |&gt; Source . add_issue ( %{ issue : :bar } ) iex&gt; Source . has_issues? ( source ) true iex&gt; Source . has_issues? ( source , 1 ) true iex&gt; Source . has_issues? ( source , :all ) true iex&gt; source = Source . update ( source , :example , code : &quot;a - b&quot; ) iex&gt; Source . has_issues? ( source ) false iex&gt; Source . has_issues? ( source , 2 ) true iex&gt; Source . has_issues? ( source , :all ) true","ref":"Rewrite.Source.html#has_issues?/2","title":"Rewrite.Source.has_issues?/2","type":"function"},{"doc":"Returns the current modules for the given source .","ref":"Rewrite.Source.html#modules/1","title":"Rewrite.Source.modules/1","type":"function"},{"doc":"Returns the modules of a source for the given version . Examples iex&gt; bar = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; def bar, do: :bar ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; foo = ...&gt; &quot;&quot;&quot; ...&gt; defmodule Foo do ...&gt; def foo, do: :foo ...&gt; end ...&gt; &quot;&quot;&quot; iex&gt; source = Source . from_string ( bar ) iex&gt; source = Source . update ( source , :example , code : bar &lt;&gt; foo ) iex&gt; Source . modules ( source ) [ Foo , Bar ] iex&gt; Source . modules ( source , 2 ) [ Foo , Bar ] iex&gt; Source . modules ( source , 1 ) [ Bar ]","ref":"Rewrite.Source.html#modules/2","title":"Rewrite.Source.modules/2","type":"function"},{"doc":"Returns the owner of the given source .","ref":"Rewrite.Source.html#owner/1","title":"Rewrite.Source.owner/1","type":"function"},{"doc":"Returns the current path for the given source .","ref":"Rewrite.Source.html#path/1","title":"Rewrite.Source.path/1","type":"function"},{"doc":"Returns the path of a source for the given version . Examples iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( &quot;some/where/plus.exs&quot; ) ...&gt; |&gt; Source . update ( :example , path : &quot;some/where/else/plus.exs&quot; ) ...&gt; Source . path ( source , 1 ) &quot;some/where/plus.exs&quot; iex&gt; Source . path ( source , 2 ) &quot;some/where/else/plus.exs&quot;","ref":"Rewrite.Source.html#path/2","title":"Rewrite.Source.path/2","type":"function"},{"doc":"Creates a new %Source{} from the given path . Examples iex&gt; source = Source . read! ( &quot;test/fixtures/source/simple.ex&quot; ) iex&gt; source . modules [ MyApp.Simple ] iex&gt; source . code &quot;&quot;&quot; defmodule MyApp.Simple do def foo(x) do x * 2 end end &quot;&quot;&quot;","ref":"Rewrite.Source.html#read!/1","title":"Rewrite.Source.read!/1","type":"function"},{"doc":"Saves the source to disk. If the source :path was updated then the old file will be deleted. The original file will also deleted when the source was marked as deleted with del/1 . Missing directories are created. Examples iex&gt; &quot;:test&quot; |&gt; Source . from_string ( ) |&gt; Source . save ( ) { :error , :nofile } iex&gt; path = &quot;tmp/foo.ex&quot; iex&gt; File . write ( path , &quot;:foo&quot; ) iex&gt; source = path |&gt; Source . read! ( ) |&gt; Source . update ( :test , code : &quot;:bar&quot; ) iex&gt; Source . save ( source ) :ok iex&gt; File . read ( path ) { :ok , &quot;:bar \\n &quot; } iex&gt; source |&gt; Source . del ( ) |&gt; Source . save ( ) iex&gt; File . exists? ( path ) false iex&gt; source = Source . from_string ( &quot;:bar&quot; ) iex&gt; Source . save ( source ) { :error , :nofile } iex&gt; source |&gt; Source . update ( :test , path : &quot;tmp/bar.ex&quot; ) |&gt; Source . save ( ) :ok iex&gt; path = &quot;tmp/ping.ex&quot; iex&gt; File . write ( path , &quot;:ping&quot; ) iex&gt; source = path |&gt; Source . read! ( ) iex&gt; new_path = &quot;tmp/pong.ex&quot; iex&gt; source |&gt; Source . update ( :test , path : new_path ) |&gt; Source . save ( ) :ok iex&gt; File . exists? ( path ) false iex&gt; File . read ( new_path ) { :ok , &quot;:ping&quot; }","ref":"Rewrite.Source.html#save/1","title":"Rewrite.Source.save/1","type":"function"},{"doc":"Updates the code or the path of a source . Examples iex&gt; source = ...&gt; &quot;a + b&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . update ( :example , path : &quot;test/fixtures/new.exs&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;a - b&quot; ) iex&gt; source . updates [ { :code , :example , &quot;a + b&quot; } , { :path , :example , nil } ] iex&gt; source . code &quot;a - b \\n &quot; If the new value equal to the current value, no updates will be added. iex&gt; source = ...&gt; &quot;a = 42&quot; ...&gt; |&gt; Source . from_string ( ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) ...&gt; |&gt; Source . update ( :example , code : &quot;b = 21&quot; ) iex&gt; source . updates [ { :code , :example , &quot;a = 42&quot; } ]","ref":"Rewrite.Source.html#update/3","title":"Rewrite.Source.update/3","type":"function"},{"doc":"Returns true if the source was updated. The optional argument kind specifies whether only :code changes or :path changes are considered. Defaults to :any . Examples iex&gt; source = Source . from_string ( &quot;a = 42&quot; ) iex&gt; Source . updated? ( source ) false iex&gt; source = Source . update ( source , :example , code : &quot;b = 21&quot; ) iex&gt; Source . updated? ( source ) true iex&gt; Source . updated? ( source , :path ) false iex&gt; Source . updated? ( source , :code ) true","ref":"Rewrite.Source.html#updated?/2","title":"Rewrite.Source.updated?/2","type":"function"},{"doc":"Returns the version of the given source . The value 1 indicates that the source has no changes.","ref":"Rewrite.Source.html#version/1","title":"Rewrite.Source.version/1","type":"function"},{"doc":"","ref":"Rewrite.Source.html#t:by/0","title":"Rewrite.Source.by/0","type":"type"},{"doc":"","ref":"Rewrite.Source.html#t:from/0","title":"Rewrite.Source.from/0","type":"type"},{"doc":"","ref":"Rewrite.Source.html#t:id/0","title":"Rewrite.Source.id/0","type":"type"},{"doc":"","ref":"Rewrite.Source.html#t:issue/0","title":"Rewrite.Source.issue/0","type":"type"},{"doc":"","ref":"Rewrite.Source.html#t:kind/0","title":"Rewrite.Source.kind/0","type":"type"},{"doc":"","ref":"Rewrite.Source.html#t:t/0","title":"Rewrite.Source.t/0","type":"type"},{"doc":"The version of a %Source{} . The version 1 indicates that the source has no changes.","ref":"Rewrite.Source.html#t:version/0","title":"Rewrite.Source.version/0","type":"type"},{"doc":"Formats the diff between two strings. Examples iex&gt; code = &quot;&quot;&quot; ...&gt; defmodule Foo do ...&gt; @moduledoc false ...&gt; ...&gt; def foo, do: :foo ...&gt; ...&gt; def three_times(x) do ...&gt; {x, ...&gt; x,x} ...&gt; end ...&gt; ...&gt; def bar(x) do ...&gt; {:bar, x} ...&gt; end ...&gt; end \\ ...&gt; &quot;&quot;&quot; iex&gt; formatted = code |&gt; Code . format_string! ( ) |&gt; IO . iodata_to_binary ( ) iex&gt; code ...&gt; |&gt; Rewrite.TextDiff . format ( formatted , color : false ) ...&gt; |&gt; IO . iodata_to_binary ( ) &quot;&quot;&quot; 1 1 |defmodule Foo do 2 - | @moduledoc false 2 + | @moduledoc false 3 3 | 4 - | def foo, do: :foo 4 + | def foo, do: :foo 5 5 | 6 6 | def three_times(x) do 7 - | {x, 8 - | x,x} 7 + | {x, x, x} 9 8 | end 10 9 | ...| &quot;&quot;&quot;","ref":"Rewrite.TextDiff.html","title":"Rewrite.TextDiff","type":"module"},{"doc":"","ref":"Rewrite.TextDiff.html#default_opts/0","title":"Rewrite.TextDiff.default_opts/0","type":"function"},{"doc":"Formats the diff between two strings. The returned iodata shows the lines with changes and 2 lines before and after the changed positions. The string contains also a gutter with line number and a - or + for removed and added lines. Multiple lines without changes are marke with ... in the gutter. Options after - the count of lines printed after each change. Defaults to 2 . before - the count of lines printed before each change. Defaults to 2 . color - enables color in the output. Defaults to truel. line - the line number of the first line. Defaults to 1 . Examples iex&gt; code = &quot;&quot;&quot; ...&gt; defmodule Bar do ...&gt; @moduledoc false ...&gt; ...&gt; bar(x, y) do ...&gt; z = x + y ...&gt; {x,y , z} ...&gt; end ...&gt; ...&gt; bar(x, y, z) do ...&gt; {x, y, z} ...&gt; end ...&gt; end \\ ...&gt; &quot;&quot;&quot; iex&gt; formatted = code |&gt; Code . format_string! ( ) |&gt; IO . iodata_to_binary ( ) iex&gt; code ...&gt; |&gt; Rewrite.TextDiff . format ( formatted , color : false ) ...&gt; |&gt; IO . iodata_to_binary ( ) &quot;&quot;&quot; ...| 4 4 | bar(x, y) do 5 5 | z = x + y 6 - | {x,y , z} 6 + | {x, y, z} 7 7 | end 8 8 | ...| &quot;&quot;&quot; iex&gt; code ...&gt; |&gt; Rewrite.TextDiff . format ( formatted , color : false , after : 1 , before : 1 ) ...&gt; |&gt; IO . iodata_to_binary ( ) &quot;&quot;&quot; ...| 5 5 | z = x + y 6 - | {x,y , z} 6 + | {x, y, z} 7 7 | end ...| &quot;&quot;&quot;","ref":"Rewrite.TextDiff.html#format/3","title":"Rewrite.TextDiff.format/3","type":"function"},{"doc":"","ref":"Rewrite.ProjectError.html","title":"Rewrite.ProjectError","type":"exception"}]